\documentclass{book}
\usepackage{makeidx}\makeindex
\usepackage{blindtext}

\newcommand{\compclass}[1]{\textsl{#1}}

\begin{document}
\chapter{Chapter One}
\blindtext\index{RE@\compclass{RE}, computably enumerable}

\section{First section}
\Blindtext

% \newcommand{\indexp}[1]{\index[p]{#1}} % https://tex.stackexchange.com/a/145326/339
\begin{figure}
  figure body
  % \caption{This is RE\protect\indexp{RE@\protect\compclass{RE}, computably enumerable}}  
  \caption{This is RE\protect\index{RE@\string\compclass{RE}, computably enumerable}}  
\end{figure}
\printindex
\end{document}